// Reference array sent to dynamic staticRenderFns
var staticRenderFns = [];

/*
Vue.directive('selecttwo', {
    twoWay: true,
    bind: function (el, binding, vnode) {
        log(el)
        log(binding)
        log(this)

        $(el).select2({
            theme: 'bootstrap',
            language: '{{ _select2_locale }}'
        });
        $(el).select2().on("select2:select", function(e) {
                this.set($(el).val());
            }.bind(binding));
    },
    update: function(el, ov) {
        log(el)
        ;
        $(el).trigger("change");
    }
});
*/

Vue.component('order-product-form', {
    mixins: [mixinTemplate],
    props: ['template', 'keyForm'],
    computed: {},
    data() {
        return Object.assign(
            {
                title: null,
                price: null,
                priceWithTax: null,
                totalWithoutTax: null,
                totalWithTax: null,
                buyingPrice: null,
                quantity: 1,
                unit: null,
                product: null
            }/*, window.productForm[this.keyForm]*/)
    },
    mounted: function () {
        this.setSelect2();

    },
    methods: {
        updateLine: function (data) {
            this.price = data.price;
            this.priceWithTax = getPriceWithTax(this.price, data.taxRate);
            this.updateQuantity();
            this.$parent.updateTotalPrice();
        },
        updateQuantity:function(){
            this.totalWithTax = this.priceWithTax * this.quantity;
            this.totalWithoutTax = this.price * this.quantity;
            this.$parent.updateTotalPrice();
        },
        setSelect2: function(){
            var monSelect = $(this.$el).find('select.form-control').select2({
                theme: 'bootstrap',
                language: 'fr'
            });
            var vue = this;
            monSelect.on('select2:select', function () {
                this.product = monSelect.val();
                $.ajax({
                    url: "http://localhost:8000/api/product/" + this.product,
                    method: "GET",
                    dataType: "",
                    success: function (response) {
                        vue.updateLine(response);
                    }
                });
            })
        }
    },
    watch: {}
});


appOrder = new Vue({
    el: '#lc-order-edit',
    delimiters: ['${', '}'],
    computed: {},
    data() {
        return Object.assign(
            {
                currentSection: 'cart',
                formOrderProductArray: [],
                indexOrderProductForm: 0,
                invoiceAddress: null,
                deliveryAddress: null,
                totalWithTax:null,
                totalWithoutTax:null,
                sectionsArray: [
                    {
                        name: 'cart',
                        nameDisplay: 'Panier'
                    },
                    {
                        name: 'addresses',
                        nameDisplay: 'Livraisons & facturations'
                    }
                ]
            })/*, window.appOrderProductFamilyValues)*/;
    },
    mounted: function () {

    },
    methods: {
        updateTotalPrice: function () {
            this.totalWithoutTax = 0;
            this.totalWithTax = 0;
            for (var i = 0; i < this.$refs.orderProductForm.length; i++) {
                var line = this.$refs.orderProductForm[i];
                this.totalWithoutTax = this.totalWithoutTax + line.totalWithoutTax;
                this.totalWithTax = this.totalWithTax + line.totalWithTax;
            }
        },
        changeSection: function (section) {
            this.updateChild();
            this.currentSection = section.name;
        },
        addOrderProductForm: function () {
            var $collectionHolder = $('#order-products-list');
            var prototype = $collectionHolder.data('prototype');
            var newForm = prototype;
            newForm = newForm.replace(/__name__/g, this.indexOrderProductForm);
            this.formOrderProductArray.push(newForm);
            this.indexOrderProductForm++;
            //updateSortableProducts();
        },

        updateChild: function () {
            if (typeof this.$refs.productForm !== 'undefined') {
                for (i = 0; i < this.$refs.productForm.length; i++) {
                    this.$refs.productForm[i].updateProductForm();
                    this.$refs.productForm[i].updateProductView();
                }
            }
        },
        getUnitReference: function () {
            if (typeof this.$refs.productUnitPrice !== 'undefined') {
                return this.$refs.productUnitPrice.unitReference;
            }
        }
    },
    watch: {
        title: function () {
            this.updateChild()
        },
    }
});
